package mn.grapecity.mmcomponent.mm_component;

import android.annotation.SuppressLint;
import android.app.KeyguardManager;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.graphics.Bitmap;
import android.graphics.Color;
import android.net.Uri;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.os.Build;
import android.os.Bundle;


import androidx.annotation.NonNull;
import androidx.annotation.RequiresApi;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;
import androidx.biometric.BiometricManager;
import androidx.biometric.BiometricPrompt;
import androidx.core.content.ContextCompat;


import android.provider.Settings;
import android.view.KeyEvent;
import android.view.View;
import android.webkit.WebBackForwardList;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Toast;

import org.json.JSONException;
import org.json.JSONObject;

import java.io.UnsupportedEncodingException;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.URLDecoder;
import java.nio.charset.StandardCharsets;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.Executor;

import io.flutter.Log;

import static mn.grapecity.mmcomponent.mm_component.MMLoginHelper.KEY_APP_VERSION;
import static mn.grapecity.mmcomponent.mm_component.MMLoginHelper.KEY_BASE_URL;
import static mn.grapecity.mmcomponent.mm_component.MMLoginHelper.KEY_BIOMETRIC_STATUS;
import static mn.grapecity.mmcomponent.mm_component.MMLoginHelper.KEY_FAIL_MODE;
import static mn.grapecity.mmcomponent.mm_component.MMLoginHelper.KEY_NAVIGATION_CHANGEMOBILE;
import static mn.grapecity.mmcomponent.mm_component.MMLoginHelper.KEY_NAVIGATION_CHANGEPIN;
import static mn.grapecity.mmcomponent.mm_component.MMLoginHelper.KEY_OPERATION;
import static mn.grapecity.mmcomponent.mm_component.MMLoginHelper.KEY_PREPS_NAME;

public class MMLoginActivity extends AppCompatActivity {
    WebView webView;

    LoginModel _loginModel;

    String _baseUrl;
    String _webUrl;
    String operation;
    String biometric;
    String biometricUrl;
    String appVersion; // application version
    String failAlertMode;

    Boolean biometricResult;

    public MMLoginActivity() {
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        JSONObject data = new JSONObject();
        try {
            data.put("navigate", "back");
        } catch (JSONException e) {
            e.printStackTrace();
        }
        MmComponentPlugin.dispatchResult(MMLoginHelper.RESULT_CODE_GOTO, data);

        return super.onKeyDown(keyCode, event);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.mm_login_activity);

        SharedPreferences prefs = getSharedPreferences(KEY_PREPS_NAME, MODE_PRIVATE);
        String mobile;

        boolean rememberme = prefs.getBoolean("rememberme", false);
        if (rememberme) {
            mobile = prefs.getString("mobile", null);
        } else {
            mobile = "";
        }

        //Хурууны хээ идэвхижүүлэх цонх гаргах функцын анхны утга
        int count = prefs.getInt("count", 0);

        //WebView url бэлдэх
        _initParams();

        // Web view
        initWebView();

    }

    public static String getDeviceIp() {
        //useIPv4 = true -> IPv4
        //useIPv4 = false -> IPv6
        boolean useIPv4 = true;
        try {
            List<NetworkInterface> interfaces = Collections.list(NetworkInterface.getNetworkInterfaces());
            for (NetworkInterface intf : interfaces) {
                List<InetAddress> addrs = Collections.list(intf.getInetAddresses());
                for (InetAddress addr : addrs) {
                    if (!addr.isLoopbackAddress()) {
                        String sAddr = addr.getHostAddress();
                        //boolean isIPv4 = InetAddressUtils.isIPv4Address(sAddr);
                        boolean isIPv4 = sAddr.indexOf(':') < 0;

                        if (isIPv4)
                            return sAddr;
                    }
                }
            }
        } catch (Exception ignored) {
        } // for now eat exceptions
        return "";
    }

    @SuppressLint("HardwareIds")
    public String getMacAddress() {
        String address = "";
        WifiManager wifiManager = (WifiManager) getApplicationContext().getSystemService(Context.WIFI_SERVICE);

        if (wifiManager.isWifiEnabled()) {
            // WIFI ALREADY ENABLED. GRAB THE MAC ADDRESS HERE
            WifiInfo info = wifiManager.getConnectionInfo();
            address = info.getMacAddress();
        } else {
            // ENABLE THE WIFI FIRST
            wifiManager.setWifiEnabled(true);

            // WIFI IS NOW ENABLED. GRAB THE MAC ADDRESS HERE
            WifiInfo info = wifiManager.getConnectionInfo();
            address = info.getMacAddress();

            // NOW DISABLE IT AGAIN
            wifiManager.setWifiEnabled(false);
        }
        return address;
    }

    @SuppressLint("HardwareIds")
    void _initParams() {
        appVersion = getIntent().getStringExtra(KEY_APP_VERSION);
//        test
//        appVersion = "60.0";
        _loginModel = new LoginModel();

        _loginModel.setDeviceIp(getDeviceIp());
        _loginModel.setDeviceMac(getMacAddress());
        _loginModel.setDeviceId(Settings.Secure.getString(getContentResolver(), Settings.Secure.ANDROID_ID));
        _loginModel.setDeviceName(Build.MANUFACTURER + " " + android.os.Build.MODEL);
        _loginModel.setAppVersion(appVersion);
        _loginModel.setOsType("ANDROID");
        _loginModel.setOsVersion(android.os.Build.VERSION.RELEASE);
    }


    @SuppressLint("SetJavaScriptEnabled")
    void initWebView() {
        //react native
        operation = getIntent().getStringExtra(KEY_OPERATION); // ali tsonhiig duudah
        biometric = getIntent().getStringExtra(KEY_BIOMETRIC_STATUS); // huruunii hee
        _baseUrl = getIntent().getStringExtra(KEY_BASE_URL); //base url
        failAlertMode = getIntent().getStringExtra(KEY_FAIL_MODE); //base url
        //test
//        _baseUrl = "http://172.16.116.92:8081";
////        _baseUrl = "http://192.168.81.126:80/";
//        biometric = "true";
//        operation = KEY_NAVIGATION_LOGIN;

        //Shared Prefs Storage
        SharedPreferences prefs = getSharedPreferences(KEY_PREPS_NAME, MODE_PRIVATE);
        String mobile = prefs.getString("mobile", null);

        final boolean rememberme = prefs.getBoolean("rememberme", false);

        if (!rememberme) {
            mobile = "";
        }

        //Webview url бэлдэх
        switch (operation) {
            case MMLoginHelper.KEY_NAVIGATION_PIN:
                //Гүйлгээний пин оруулах
                _webUrl = _baseUrl + "/p2p.aspx";
                break;
            case KEY_NAVIGATION_CHANGEPIN:
                //pin солих
                _webUrl = _baseUrl + "/changepin.aspx";
                break;
            case MMLoginHelper.KEY_NAVIGATION_LOGIN:
                //Login хийх
                _webUrl = _baseUrl + "/login.aspx" + "?" + LoginHeader.DEVICE_ID + "=" + _loginModel.deviceId
                        + "&" + LoginHeader.DEVICE_NAME + "=" + _loginModel.deviceName
                        + "&" + LoginHeader.DEVICE_IP + "=" + _loginModel.deviceIp + "&" + LoginHeader.DEVICE_MAC + "=" + _loginModel.deviceMac
                        + "&" + LoginHeader.OS_TYPE + "=" + _loginModel.osType + "&" + LoginHeader.APP_VERSION + "=" + _loginModel.appVersion +
                        "&" + LoginHeader.OS_VERSION + "=" + _loginModel.osVersion + "&" + LoginHeader.MOBILE + "=" + mobile + "&" + LoginHeader.REMEMBER_ME + "=" + rememberme;

                biometricUrl = _baseUrl + "/fingerprint.aspx";

                int count = prefs.getInt("count", 0);
                SharedPreferences.Editor editor = prefs.edit();

                if (count < 4) {
                    _webUrl = _webUrl + "&biometricType=true";//iOS => FID = FaceID, TID = TouchID
                    count++;
                    editor.putInt("count", count);
                    editor.apply();
                }else{
                    //Хурууны хээгээр нэвтрэхийг идэвхижүүлсэн тохиолдолд fingerprint товч гаргаж ирэх flag
                    if(Boolean.parseBoolean(biometric))
                    _webUrl = _webUrl + "&biometricType=enabled";
                }
                break;
            case KEY_NAVIGATION_CHANGEMOBILE:
                _webUrl = _baseUrl + "/changemobile.aspx";
                break;
            default:
                JSONObject data = null;
                try {
                    data.put("desc", "wrong navigation key");
                    data.put("code", 101);
                } catch (JSONException e) {
                    e.printStackTrace();
                }
                MmComponentPlugin.dispatchResult(MMLoginHelper.RESULT_CODE_FAILED, data);
        }

        try {
            webView = findViewById(R.id.webView1);

            //Webview settings
            webView.getSettings().setJavaScriptEnabled(true);
            webView.getSettings().setDomStorageEnabled(true);

            //Location service
            webView.getSettings().setJavaScriptCanOpenWindowsAutomatically(true);
            webView.getSettings().setGeolocationEnabled(true);
//            webView.setWebChromeClient(new WebChromeClient());
            webView.setWebChromeClient(new WebChromeClient() {
            });

            webView.getSettings().setCacheMode(WebSettings.LOAD_DEFAULT);

            final String[] historyUrl = new String[1];

            webView.setOnKeyListener(new View.OnKeyListener() {
                @Override
                public boolean onKey(View v, int keyCode, KeyEvent event) {
                    WebBackForwardList mWebBackForwardList = webView.copyBackForwardList();
                    if (mWebBackForwardList.getCurrentIndex() > 0)
                        historyUrl[0] = mWebBackForwardList.getItemAtIndex(mWebBackForwardList.getCurrentIndex() - 1).getUrl();

                    if (event.getAction() == KeyEvent.ACTION_DOWN) {
                        WebView webView = (WebView) v;
                        if (keyCode == KeyEvent.KEYCODE_BACK) {
                            if (webView.canGoBack()) {
                                if (historyUrl[0].contains("/verifytan.aspx")) {
                                    String prevUrl = mWebBackForwardList.getItemAtIndex(mWebBackForwardList.getCurrentIndex() - 2).getUrl();
                                    webView.loadUrl(prevUrl);
                                }
                                return true;
                            }
                        }
                    }

                    return false;
                }
            });

            webView.setWebViewClient(new WebViewClient() {
                                         @RequiresApi(api = Build.VERSION_CODES.KITKAT)
                                         @Override
                                         public void onPageStarted(WebView view, String url, Bitmap favicon) {
                                             super.onPageStarted(view, url, favicon);
                                         }

                                         @Override
                                         public void onPageFinished(WebView view, String url) {
                                         }

                                         @Override
                                         public void onLoadResource(WebView view, String url) {
                                         }


                                         @RequiresApi(api = Build.VERSION_CODES.KITKAT)
                                         @Override
                                         public boolean shouldOverrideUrlLoading(WebView view, String url) {
                                             Uri uri = Uri.parse(url);
                                             boolean bool = false;
                                             String result = null;
                                             if (url.contains("/success")) {
                                                 //success
                                                 Log.d("success",url.toString());
                                                 String op = uri.getQueryParameter("op");
                                                 if (MMLoginHelper.KEY_NAVIGATION_LOGIN.equals(op)) {
                                                     SharedPreferences prefs = getSharedPreferences(KEY_PREPS_NAME, MODE_PRIVATE);
                                                     SharedPreferences.Editor editor = prefs.edit();
                                                     String mobile = uri.getQueryParameter("mobile");

                                                     boolean rememberme = Boolean.parseBoolean(uri.getQueryParameter("rememberme"));
                                                     editor.putBoolean("rememberme", rememberme);


                                                     if (rememberme) {
                                                         String oldMobile = prefs.getString("mobile", "");
                                                         assert oldMobile != null;
                                                         if (oldMobile.equals(mobile)) {
                                                             if (url.contains("biometric")) {
                                                                 biometricResult = Boolean.parseBoolean(uri.getQueryParameter("biometric"));
                                                                 if (biometricResult) {
                                                                     editor.putInt("count", 4);
                                                                 }
                                                             }
                                                         } else {
                                                             editor.putString("mobile", mobile);
                                                             if (url.contains("biometric")) {
                                                                 biometricResult = Boolean.parseBoolean(uri.getQueryParameter("biometric"));
                                                                 if (biometricResult) {
                                                                     editor.putInt("count", 4);
                                                                 }
                                                             }
                                                         }

                                                     } else {
                                                         editor.putString("mobile", "");
                                                     }


                                                     editor.apply();

                                                     JSONObject data = null;
                                                     try {
                                                         data = urlParamToJSON(url);
                                                     } catch (UnsupportedEncodingException e) {
                                                         e.printStackTrace();
                                                     }
                                                     if (url.contains("desc")) {
                                                         String desc = uri.getQueryParameter("desc");
                                                         assert desc != null;
                                                         if (desc.length() > 0) {
                                                             Toast.makeText(MMLoginActivity.this, desc, Toast.LENGTH_LONG).show();
                                                         }
                                                     }
                                                     MmComponentPlugin.dispatchResult(MMLoginHelper.RESULT_CODE_SUCCESS, data);
                                                     finish();
                                                     return true;
                                                 } else if (MMLoginHelper.KEY_NAVIGATION_FORGETPIN.equals(op) || KEY_NAVIGATION_CHANGEMOBILE.equals(op)) {
                                                     String desc = uri.getQueryParameter("desc");
                                                     JSONObject data = null;
                                                     try {
                                                         data = urlParamToJSON(url);
                                                     } catch (UnsupportedEncodingException e) {
                                                         e.printStackTrace();
                                                     }

                                                     Toast.makeText(getApplicationContext(), desc, Toast.LENGTH_LONG).show();
                                                     MmComponentPlugin.dispatchResult(MMLoginHelper.RESULT_CODE_SUCCESS, data);
                                                     return true;
                                                 } else {
                                                     String desc = uri.getQueryParameter("desc");
                                                     JSONObject data = null;
                                                     try {
                                                         data = urlParamToJSON(url);
                                                     } catch (UnsupportedEncodingException e) {
                                                         e.printStackTrace();
                                                     }

                                                     Toast.makeText(MMLoginActivity.this, desc, Toast.LENGTH_LONG).show();
                                                     MmComponentPlugin.dispatchResult(MMLoginHelper.RESULT_CODE_SUCCESS, data);
                                                     finish();
                                                     return true;
                                                 }
                                             } else if (url.contains("/failed")) {
                                                 //failed
                                                 SharedPreferences prefs = getSharedPreferences(KEY_PREPS_NAME, MODE_PRIVATE);
                                                 SharedPreferences.Editor editor = prefs.edit();

                                                 String op = uri.getQueryParameter("op");
                                                 // Серверээс тогтмол хандахыг шаардсан хурууны хээг идэвхигүй болгосон үед RN талын утгыг өөрчлөх
                                                 if (KEY_BIOMETRIC_STATUS.equals(op)) {

                                                     JSONObject data = null;
                                                     try {
                                                         data = urlParamToJSON(url);
                                                     } catch (UnsupportedEncodingException e) {
                                                         e.printStackTrace();
                                                     }
                                                     String desc = uri.getQueryParameter("desc");
                                                     alert("Алдаа!", desc, "OK");
                                                     MmComponentPlugin.dispatchResult(MMLoginHelper.RESULT_CODE_FAILED, data);
                                                 } else {
                                                     JSONObject data = null;
                                                     try {
                                                         data = urlParamToJSON(url);
                                                     } catch (UnsupportedEncodingException e) {
                                                         e.printStackTrace();
                                                     }

                                                     String desc = uri.getQueryParameter("desc");
                                                     alert("Анхааруулга", desc, "OK");
                                                     MmComponentPlugin.dispatchResult(MMLoginHelper.RESULT_CODE_FAILED, data);
                                                 }
                                                 bool = true;
                                                 editor.commit();
                                             } else if (url.contains("/goto")) {
                                                 //Navigate
                                                 String navigate = uri.getQueryParameter("navigate");
                                                 //callback
                                                 JSONObject data = new JSONObject();
                                                 try {
                                                     data.put("navigate", navigate);
                                                 } catch (JSONException e) {
                                                     e.printStackTrace();
                                                 }
                                                 MmComponentPlugin.dispatchResult(MMLoginHelper.RESULT_CODE_GOTO, data);
                                                 bool = true;
                                                 finish();
                                             } else if (url.contains("/fingerprint")) {
                                                 Log.d("Fingerprint",url.toString());
                                                 biometricAuth(webView, rememberme, Boolean.parseBoolean(biometric), false);
                                                 bool = true;
                                             } else if (url.contains("?redirect=")) {

                                                 //redirect to web
                                                 String desc = uri.getQueryParameter("desc");
                                                 alert("Анхааруулга", desc, "OK");
                                                 bool = false;

                                             } else if (url.contains("/sendpinfp")) {

                                                 if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
                                                     KeyguardManager keyguardManager = (KeyguardManager) getApplicationContext().getSystemService(Context.KEYGUARD_SERVICE);
                                                     Intent intent = keyguardManager.createConfirmDeviceCredentialIntent("Пин код имэйлдэх", "хурууны хээгээ уншуулна уу");
                                                     if (intent != null && intent.resolveActivity(getPackageManager()) != null) {
                                                         startActivityForResult(intent, MMLoginHelper.LOCK_REQUEST_CODE);
                                                     }
                                                 }
                                                 bool = true;
                                             } else if (url.contains("/loginfp")) {
                                                 SharedPreferences prefs = getSharedPreferences(KEY_PREPS_NAME, MODE_PRIVATE);

                                                 boolean rememberme = prefs.getBoolean("rememberme", false);

                                                 // сануулсан болон хурууны хээ идэвхитэй нөхцөлд ХХ гарч ирнэ
                                                 biometricAuth(webView, rememberme, Boolean.parseBoolean(biometric), true);

                                                 bool = true;
                                             }
                                             return bool;
                                         }
                                     }
            );

            // Init

            //load url error handling
            if (!DetectConnection.checkInternetConnection(this)) {
                String htmlData = "<html><body style=\"background-color: #f9fafa;\"><div align=\"center\" style=\"font-size:18px; font-weight: bold; margin-top: 40%;\" >Холболт тасарлаа</div>" +
                        "<div align=\"center\" style=\"font-size:16px; margin-top: 20px \" >Интернет холболтоо шалгана уу</div></body>";
                webView.loadUrl("about:blank");
                webView.loadDataWithBaseURL(null, htmlData, "text/html", "UTF-8", null);
                webView.getSettings().setJavaScriptEnabled(true);
                webView.invalidate();
            } else {
                webView.loadUrl(_webUrl);
            }
        } catch (Exception e) {
            e.printStackTrace();
            Toast.makeText(this, getResources().getString(R.string.mm_error_occurred), Toast.LENGTH_SHORT).show();
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        switch (requestCode) {
            case MMLoginHelper.LOCK_REQUEST_CODE:
                if (resultCode == RESULT_OK) {
                    webView.loadUrl(_baseUrl + "/secquestion.aspx?fpenable=true");
                }
                break;
        }
    }


    void biometricAuth(final WebView view, final boolean rememberme, boolean biometric, final boolean isLogin) {

        int canAuthenticate = BiometricManager.from(getApplicationContext()).canAuthenticate();
        JSONObject res = new JSONObject();
        try {
            res.put("code", 101);
        } catch (JSONException e) {
            e.printStackTrace();
        }
        switch (canAuthenticate) {
            case BiometricManager.BIOMETRIC_ERROR_NONE_ENROLLED:
                try {
                    res.put("desc", "Та хурууны хээгээ гар утсан дээрээ тохируулсны дараа хурууны хээгээр нэвтэрнэ үү.");//FPNOTENROLLED
                    res.put("biometric", false);//FPNOTENROLLED
                } catch (JSONException e) {
                    e.printStackTrace();
                }
                alert("Анхааруулга", "Та хурууны хээгээ гар утсан дээрээ тохируулсны дараа хурууны хээгээр нэвтэрнэ үү.", "OK");
                MmComponentPlugin.dispatchResult(MMLoginHelper.RESULT_CODE_FAILED, res);
                break;
            case BiometricManager.BIOMETRIC_ERROR_HW_UNAVAILABLE:
                //TODO
                try {
                    res.put("desc", "Хурууны хээ дэмжихгүй төхөөрөмж"); // FPNOTAVAILABLE
                } catch (JSONException e) {
                    e.printStackTrace();
                }
                alert("Анхааруулга", "Хурууны хээ дэмжихгүй төхөөрөмж", "OK");
                MmComponentPlugin.dispatchResult(MMLoginHelper.RESULT_CODE_FAILED, res);
                break;
            case BiometricManager.BIOMETRIC_ERROR_NO_HARDWARE:
                //TODO
                try {
                    res.put("desc", "Хурууны хээ дэмжихгүй төхөөрөмж");
                    res.put("biometric", false);
                } catch (JSONException e) {
                    e.printStackTrace();
                }
                alert("Анхааруулга", "Хурууны хээ дэмжихгүй төхөөрөмж", "OK");
                MmComponentPlugin.dispatchResult(MMLoginHelper.RESULT_CODE_FAILED, res);
                break;
            case BiometricManager.BIOMETRIC_SUCCESS:
                //executor
                Executor executor = ContextCompat.getMainExecutor(this);

                //prompt
                BiometricPrompt biometricPrompt = new BiometricPrompt(MMLoginActivity.this, executor, new BiometricPrompt.AuthenticationCallback() {
                    @Override
                    public void onAuthenticationError(int errorCode, @NonNull CharSequence errString) {
                        super.onAuthenticationError(errorCode, errString);

                        JSONObject error = new JSONObject();
                        try {
                            if (errorCode == 7) {
                                error.put("code", 101);
                                error.put("biometric", false);
                                error.put("desc", "Хурууны хээгээр нэвтрэх бүртгэл цуцлагдлаа.");//FPBIOMETRYLOCKED
                            }
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }

                        MmComponentPlugin.dispatchResult(MMLoginHelper.RESULT_CODE_FAILED, error);
                    }

                    @Override
                    public void onAuthenticationSucceeded(@NonNull BiometricPrompt.AuthenticationResult result) {
                        super.onAuthenticationSucceeded(result);
                        if (isLogin) {
                            if (rememberme) {
                                _webUrl = _webUrl + "&from=biometric";
                                view.loadUrl(_webUrl);
                            } else {
                                JSONObject error = new JSONObject();
                                try {
                                    alert("Анхааруулга", "Нэвтрэх мэдээлэл сануулаагүй тул хурууны хээгээр нэвтрэх боломжгүй.", "OK");
                                    error.put("code", 101);
                                    error.put("biometric", false);
                                    error.put("desc", "Нэвтрэх мэдээлэл сануулаагүй тул хурууны хээгээр нэвтрэх боломжгүй.");
                                } catch (JSONException e) {
                                    e.printStackTrace();
                                }
                                MmComponentPlugin.dispatchResult(MMLoginHelper.RESULT_CODE_FAILED, error);
                            }
                        } else {
                            view.loadUrl(biometricUrl + "?fpenable=true");
                        }
                    }

                    @Override
                    public void onAuthenticationFailed() {
                        super.onAuthenticationFailed();
                    }
                }
                );

                BiometricPrompt.PromptInfo promptInfo = new BiometricPrompt.PromptInfo.Builder()
                        .setTitle("Нэвтрэх")
                        .setDescription("Хурууны хээгээ баталгаажуулна уу")
                        .setNegativeButtonText("Болих")
                        .build();

                // сануулсан болон хурууны хээ идэвхитэй нөхцөлд ХХ гарч ирнэ
                if (isLogin) {
                    if (biometric) {
                        biometricPrompt.authenticate(promptInfo);
                    }
                } else {
                    if (rememberme) {
                        biometricPrompt.authenticate(promptInfo);
                    }
                }
        }
    }

    @RequiresApi(api = Build.VERSION_CODES.KITKAT)
    JSONObject urlParamToJSON(String query) throws UnsupportedEncodingException {
        query = java.net.URLDecoder.decode(query, StandardCharsets.UTF_8.name());
        final String myStringDecoded = URLDecoder.decode(query, "UTF-8");
        String[] params = myStringDecoded.split("\\?");
        String[] parts = params[params.length - 1].split("&");


        JSONObject json = new JSONObject();

        for (String part : parts) {
            String[] keyVal = part.split("="); // The equal separates key and values
            try {
                json.put(keyVal[0], keyVal[1]);
            } catch (JSONException e) {
                e.printStackTrace();
            }
        }
        return json;
    }


    void alert(String title, String message, String buttonText) {
        if (failAlertMode.equals("MODE_ALERT")) {
            final AlertDialog alertDialog = new AlertDialog.Builder(MMLoginActivity.this).create();
            alertDialog.setTitle(title);
            alertDialog.setMessage(message);
            alertDialog.setButton(AlertDialog.BUTTON_NEGATIVE, buttonText,
                    new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {
                            if (operation.equals(KEY_BIOMETRIC_STATUS)) {
                                finish();
                            }
                            dialog.dismiss();
                        }
                    });
            //2. now setup to change color of the button
            alertDialog.setOnShowListener(new DialogInterface.OnShowListener() {
                @Override
                public void onShow(DialogInterface arg0) {
                    alertDialog.getButton(AlertDialog.BUTTON_NEGATIVE).setTextColor(Color.rgb(15, 60, 106));
                }
            });

            alertDialog.show();
        } else {
            Toast.makeText(MMLoginActivity.this, message, Toast.LENGTH_LONG).show();
        }
    }
}
